osg::FrameBufferObject Class Reference

`#include <FrameBufferObject>`

Inheritance diagram for osg::FrameBufferObject:

## Public Types

enum | BindTarget { READ_FRAMEBUFFER = GL_READ_FRAMEBUFFER_EXT , DRAW_FRAMEBUFFER = GL_DRAW_FRAMEBUFFER_EXT , READ_DRAW_FRAMEBUFFER = GL_FRAMEBUFFER_EXT }
typedef std::map< Camera::BufferComponent, FrameBufferAttachment > | AttachmentMap
typedef std::vector< GLenum > | MultipleRenderingTargets
typedef Camera::BufferComponent | BufferComponent
Public Types inherited from osg::StateAttribute
enum | Values { OFF = 0x0 , ON = 0x1 , OVERRIDE = 0x2 , PROTECTED = 0x4 , INHERIT = 0x8 }

enum

Type {
TEXTURE , POLYGONMODE , POLYGONOFFSET , MATERIAL ,
ALPHAFUNC , ANTIALIAS , COLORTABLE , CULLFACE ,
FOG , FRONTFACE , LIGHT , POINT ,
LINEWIDTH , LINESTIPPLE , POLYGONSTIPPLE , SHADEMODEL ,
TEXENV , TEXENVFILTER , TEXGEN , TEXMAT ,
LIGHTMODEL , BLENDFUNC , BLENDEQUATION , LOGICOP ,
STENCIL , COLORMASK , DEPTH , VIEWPORT ,
SCISSOR , BLENDCOLOR , MULTISAMPLE , CLIPPLANE ,
COLORMATRIX , VERTEXPROGRAM , FRAGMENTPROGRAM , POINTSPRITE ,
PROGRAM , CLAMPCOLOR , HINT , SAMPLEMASKI ,
PRIMITIVERESTARTINDEX , CLIPCONTROL , VALIDATOR , VIEWMATRIXEXTRACTOR ,
OSGNV_PARAMETER_BLOCK , OSGNVEXT_TEXTURE_SHADER , OSGNVEXT_VERTEX_PROGRAM , OSGNVEXT_REGISTER_COMBINERS ,
OSGNVCG_PROGRAM , OSGNVSLANG_PROGRAM , OSGNVPARSE_PROGRAM_PARSER , UNIFORMBUFFERBINDING ,
TRANSFORMFEEDBACKBUFFERBINDING , ATOMICCOUNTERBUFFERBINDING , PATCH_PARAMETER , FRAME_BUFFER_OBJECT ,
VERTEX_ATTRIB_DIVISOR , SHADERSTORAGEBUFFERBINDING , INDIRECTDRAWBUFFERBINDING , VIEWPORTINDEXED ,
DEPTHRANGEINDEXED , SCISSORINDEXED , BINDIMAGETEXTURE , SAMPLER ,
CAPABILITY = 100
}

typedef GLenum | GLMode
typedef unsigned int | GLModeValue
typedef unsigned int | OverrideValue
typedef std::pair< Type, unsigned int > | TypeMemberPair
typedef std::vector< StateSet * > | ParentList
typedef osg::StateAttributeCallback | Callback
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| FrameBufferObject ()
| FrameBufferObject (const FrameBufferObject &copy, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_StateAttribute (osg, FrameBufferObject, FRAME_BUFFER_OBJECT)
const AttachmentMap & | getAttachmentMap () const
void | setAttachment (BufferComponent attachment_point, const FrameBufferAttachment &attachment)
const FrameBufferAttachment & | getAttachment (BufferComponent attachment_point) const
bool | hasAttachment (BufferComponent attachment_point) const
bool | hasMultipleRenderingTargets () const
const MultipleRenderingTargets & | getMultipleRenderingTargets () const
bool | isMultisample () const
int | compare (const StateAttribute &sa) const
void | apply (State &state) const
GLuint | getHandle (unsigned int contextID) const
void | apply (State &state, BindTarget target) const
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osg::StateAttribute
| StateAttribute ()
| StateAttribute (const StateAttribute &sa, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Texture * | asTexture ()
virtual const Texture * | asTexture () const
virtual Type | getType () const =0
virtual unsigned int | getMember () const
TypeMemberPair | getTypeMemberPair () const
virtual bool | isTextureAttribute () const
bool | operator< (const StateAttribute &rhs) const
bool | operator== (const StateAttribute &rhs) const
bool | operator!= (const StateAttribute &rhs) const
const ParentList & | getParents () const
StateSet * | getParent (unsigned int i)
const StateSet * | getParent (unsigned int i) const
unsigned int | getNumParents () const
void | setShaderComponent (ShaderComponent *sc)
ShaderComponent * | getShaderComponent ()
const ShaderComponent * | getShaderComponent () const
virtual bool | getModeUsage (ModeUsage &) const
virtual bool | checkValidityOfAssociatedModes (osg::State &) const
void | setUpdateCallback (StateAttributeCallback *uc)
StateAttributeCallback * | getUpdateCallback ()
const StateAttributeCallback * | getUpdateCallback () const
void | setEventCallback (StateAttributeCallback *ec)
StateAttributeCallback * | getEventCallback ()
const StateAttributeCallback * | getEventCallback () const
virtual void | compileGLObjects (State &) const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~FrameBufferObject ()
FrameBufferObject & | operator= (const FrameBufferObject &)
void | updateDrawBuffers ()
void | dirtyAll ()
GLenum | convertBufferComponentToGLenum (BufferComponent attachment_point) const
Protected Member Functions inherited from osg::StateAttribute
virtual | ~StateAttribute ()
void | addParent (osg::StateSet *object)
void | removeParent (osg::StateSet *object)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Attributes inherited from osg::StateAttribute
ParentList | _parents
ref_ptr< ShaderComponent > | _shaderComponent
ref_ptr< StateAttributeCallback > | _updateCallback
ref_ptr< StateAttributeCallback > | _eventCallback
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Member Typedef Documentation

## AttachmentMap

typedef std::map<Camera::BufferComponent, FrameBufferAttachment> osg::FrameBufferObject::AttachmentMap

## BufferComponent

typedef Camera::BufferComponent osg::FrameBufferObject::BufferComponent

## MultipleRenderingTargets

typedef std::vector<GLenum> osg::FrameBufferObject::MultipleRenderingTargets

## Member Enumeration Documentation

## BindTarget

enum osg::FrameBufferObject::BindTarget

Enumerator
READ_FRAMEBUFFER |
DRAW_FRAMEBUFFER |
READ_DRAW_FRAMEBUFFER |

## Constructor & Destructor Documentation

## FrameBufferObject() [1/2]

osg::FrameBufferObject::FrameBufferObject | ( |  | ) |

Referenced by FrameBufferObject(), META_StateAttribute(), and operator=().

## FrameBufferObject() [2/2]

osg::FrameBufferObject::FrameBufferObject | ( | const FrameBufferObject & | copy,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

References FrameBufferObject(), and osg::CopyOp::SHALLOW_COPY.

## ~FrameBufferObject()

virtual osg::FrameBufferObject::~FrameBufferObject | ( |  | ) |

protected virtual

## Member Function Documentation

## apply() [1/2]

void osg::FrameBufferObject::apply | ( | State & |  | ) | const

virtual

apply the OpenGL state attributes. The render info for the current OpenGL context is passed in to allow the StateAttribute to obtain details on the the current context and state.

Reimplemented from osg::StateAttribute.

## apply() [2/2]

void osg::FrameBufferObject::apply | ( | State & | state,
|  | BindTarget | target ) const

Bind the FBO as either the read or draw target, or both.

## compare()

int osg::FrameBufferObject::compare | ( | const StateAttribute & | sa | ) | const

virtual

Return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs.

Implements osg::StateAttribute.

References osg::StateAttribute::StateAttribute().

## convertBufferComponentToGLenum()

GLenum osg::FrameBufferObject::convertBufferComponentToGLenum | ( | BufferComponent | attachment_point | ) | const

protected

## dirtyAll()

void osg::FrameBufferObject::dirtyAll | ( |  | ) |

inline protected

Referenced by updateDrawBuffers().

## getAttachment()

const FrameBufferAttachment & osg::FrameBufferObject::getAttachment | ( | FrameBufferObject::BufferComponent | attachment_point | ) | const

inline

Referenced by setAttachment().

## getAttachmentMap()

const FrameBufferObject::AttachmentMap & osg::FrameBufferObject::getAttachmentMap | ( |  | ) | const

inline

Referenced by META_StateAttribute().

## getHandle()

GLuint osg::FrameBufferObject::getHandle | ( | unsigned int | contextID | ) | const

inline

## getMultipleRenderingTargets()

const MultipleRenderingTargets & osg::FrameBufferObject::getMultipleRenderingTargets | ( |  | ) | const

inline

## hasAttachment()

bool osg::FrameBufferObject::hasAttachment | ( | FrameBufferObject::BufferComponent | attachment_point | ) | const

inline

Referenced by setAttachment().

## hasMultipleRenderingTargets()

bool osg::FrameBufferObject::hasMultipleRenderingTargets | ( |  | ) | const

inline

## isMultisample()

bool osg::FrameBufferObject::isMultisample | ( |  | ) | const

## META_StateAttribute()

osg::FrameBufferObject::META_StateAttribute | ( | osg | ,
|  | FrameBufferObject | ,
|  | FRAME_BUFFER_OBJECT | )

References osg::StateAttribute::FRAME_BUFFER_OBJECT, FrameBufferObject(), and getAttachmentMap().

## operator=()

FrameBufferObject & osg::FrameBufferObject::operator= | ( | const FrameBufferObject & |  | ) |

inline protected

References FrameBufferObject().

## releaseGLObjects()

virtual void osg::FrameBufferObject::releaseGLObjects | ( | osg::State * | = 0 | ) | const

virtual

If State is non-zero, this function releases any associated OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objexts for all graphics contexts.

Reimplemented from osg::StateAttribute.

## resizeGLObjectBuffers()

virtual void osg::FrameBufferObject::resizeGLObjectBuffers | ( | unsigned int | maxSize | ) |

virtual

Resize any per context GLObject buffers to specified size.

Reimplemented from osg::StateAttribute.

## setAttachment()

void osg::FrameBufferObject::setAttachment | ( | BufferComponent | attachment_point,
|  | const FrameBufferAttachment & | attachment )

References getAttachment(), and hasAttachment().

## updateDrawBuffers()

void osg::FrameBufferObject::updateDrawBuffers | ( |  | ) |

protected

References dirtyAll().

The documentation for this class was generated from the following file:

- FrameBufferObject